﻿// Create an empty dialog window near the upper left of the screen
function SuperluminalUtilitiesWindow(windowResourceFolder) {
	this.windowResourceFolder = windowResourceFolder;
	this.width = 400;
	this.height = 300;
	this.result = null;
	
	
	this.entryWidth = 200;
	this.entryHeight = 35;
	this.xGap = 2;
	this.yGap = 2;
	this.paramEntryHeight = 25;
	this.paramEntryMargins = 1;
	this.paramEntryGap = 1;
	this.groupMargins = 5;
	this.groupGap = 5;	
	this.displayedUtilities= [];

	this.SetupMainWindow = function() {
		this.window = new Window('dialog', 'Stardust Utilities');
		
		//this.window.properties.
		this.window.frameLocation = [100,100];
		this.window.size = [this.width,this.height];
		this.window.orientation = 'column';
		this.window.alignChildren = ['fill','top'];
		
		var g = this.window.graphics;
		g.backgroundColor = g.newBrush(g.BrushType.SOLID_COLOR, [0.15, 0.15, 0.15, 1]);
		//this.window.backgroundColor = [1,1,1,1];
		//this.window.preferredSize = [400, 0];
		
		var offset_y = 10;
		var offset_x = 5;

		var bounds = [offset_x, offset_y, offset_x + 130, offset_y + 30];
		
		
		/*
		var b = this.window.add('button', undefined, "Create Studio Camera");
		b.windowObj = this;
		b.bounds = bounds;
		b.onClick = function() { 
			//var res = '({operation:"ok", data:"' + this.windowObj.data.toSource() + '"})';
			this.windowObj.result = '{ "operation": "create model cam" }';
			this.windowObj.window.close();
		}

		bounds[1] += 35;
		bounds[3] += 35;
		b = this.window.add('button', undefined, "Save Preset");
		b.windowObj = this;
		b.bounds = bounds;
		b.onClick = function() { 
			//var res = '({operation:"ok", data:"' + this.windowObj.data.toSource() + '"})';
			this.windowObj.result = '{ "operation": "general presets" }';
			this.windowObj.window.close();
		}
	  */
	  
	  
		//add "cancel" button.
		var cancel = this.window.add('button', undefined, "Close");
		cancel.windowObj = this;
         cancel.bounds = [this.width - 100 - offset_x, this.height - 30- offset_y, this.width -offset_x, this.height - offset_y];
         cancel.onClick = function() {
            this.windowObj.result = "null";
			this.windowObj.window.close();
		}
		
		var entry_save = {};
		entry_save.name = "Save Presets";	
		entry_save.buttonLabel = "Open";	

		entry_save.return_msg = "general presets";
		entry_save.windowObj = this;
		var save_but = this.CreateGroupEntry(this.window, entry_save);
		save_but.group.location = [ 5, 10];
		this.displayedUtilities.push(save_but);	
		
		
		var entry_camera = {};
		entry_camera.name = "Studio Camera";	
		entry_camera.buttonLabel = "Create";	
		entry_camera.return_msg = "create model cam";
		entry_camera.windowObj = this;
		var cam_but = this.CreateGroupEntry(this.window, entry_camera);
		cam_but.group.location = [ 5, 50];
		this.displayedUtilities.push(cam_but);	
	
	}

		this.CreateGroupEntry = function(container, entryData) {
		var entry = { entryData: entryData };
		
		entry.group = container.add("group", undefined);
		entry.group.bounds = [this.paramEntryMargins, this.paramEntryMargins, container.bounds.width - 10 , this.entryHeight];
		var g = entry.group.graphics;
		g.backgroundColor = g.newBrush(g.BrushType.SOLID_COLOR, [0.11, 0.11, 0.11,1]);
		
		entry.text = entry.group.add("statictext", undefined,  entryData.name);
		var name_marg = 20;
		entry.text.size = [300 - name_marg, this.entryHeight];
		entry.text.location = [this.paramEntryMargins + name_marg, 0];
		
		entry.button = entry.group.add('button', undefined, entryData.buttonLabel);
		entry.button.bounds = [container.bounds.width  - 130, this.paramEntryMargins, container.bounds.width - 10 , this.entryHeight];
		
		entry.button.windowObj  = entryData.windowObj;
		
	//	var g1= entry.button.graphics;
		//g1.backgroundColor = g1.newBrush(g.BrushType.SOLID_COLOR, [0.11, 0.11, 0.11,1]);

		entry.button.return_msg = entryData.return_msg;
		entry.button.onClick = function() { 
			this.windowObj.result = '{ "operation": "'+this.return_msg+'" }';
			this.windowObj.window.close();
		}
		
		return entry;

	}	
		
	this.LaunchWindow = function() {
		//this.window.layout.layout(true);
		//this.window.layout.resize();
		//this.window.onResizing = this.window.onResize = function () {this.layout.resize();}
		//this.window.resizeable = true;
		

		
		this.window.center();
		//this.window.size = [500,400];//disable this for snug fit.
		this.window.show();
	}

	this.Pipeline = function() {
		this.SetupMainWindow();
		this.LaunchWindow();
	}

	//pipeline
	this.Pipeline();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//PIPELINE
function SuperluminalLaunchUtilitiesWindow(resource) {
	var windowObj = new SuperluminalUtilitiesWindow(resource);
	return windowObj.result;
}

//SuperluminalLaunchUtilitiesWindow();